//https://www.ibenic.com/ultimate-guide-for-javascript-in-elementor-widgets/
( function( $ ) {

    "use strict";

    $( window ).on( 'elementor/frontend/init', function() {

        const actionsPack = ( $element ) => {

            // Country Code
            let $telInputs = $element.find('.ap_intl_tel_input');
            $.each($telInputs, function (){
                intlTelInput( this, {
                    allowExtensions: true,
                    nationalMode: true,
                    separateDialCode: true,
                    utilsScript: "https://cdn.jsdelivr.net/npm/intl-tel-input@17.0.3/build/js/utils.js",
                    initialCountry: "auto",
                    allowDropdown: true,
                    formatOnDisplay: false,
                    hiddenInput: $(this).attr('name').replace( /(^.*\[|\].*$)/g, '' ),
                    geoIpLookup: function(success, failure) {
                        $.get("https://ipinfo.io", function() {}, "jsonp").always(function(resp) {
                            let countryCode = (resp && resp.country) ? resp.country : "us";
                            success(countryCode);
                        });
                    },
                });
            });

            // Floating Labels
            let $floatingLabels = $(".ap-floating-label");
            $.each($floatingLabels, function(){
                $(this).find('input, textarea').focus(function(){
                    $(this).prev('label').addClass('focused');
                });
                $(this).find('input, textarea').on('change', function(){
                    $(this).prev('label').addClass('focused');
                });
                $(this).find('input, textarea').blur(function(){
                    if($(this).val() === ''){
                        $(this).prev().removeClass('focused');
                    }
                });
            });

        };

        elementorFrontend.hooks.addAction( 'frontend/element_ready/form.default', actionsPack );
    });

}(jQuery));