(function( $ ) {

    let
        $document = $(document),
        $form = null, // Jquery Instance of Frontend Form
        formWidgetSettings = null, // All setting of Form widget
        $iframe = $('#elementor-preview-iframe')[0]
    ;

    // Instantiate variables when Form Widget is opened inside Elementor's Editor
    elementor.hooks.addAction( 'panel/open_editor/widget/form', ( panel, model, view )=>{
        formWidgetSettings = elementorFrontend.config.elements.data[model.cid].attributes;
        $form = view.$el; // Frontend Form
    });


//*********************************************************** Variable Interpolation ***********************************
    // {{{apUserAdditionalTitle()}}}
    window.apUserAdditionalTitle = function( label1, label2 ) {
        if (label1 === 'custom'){
            return label2;
        }
        else{
            return label1;
        }
    }

//********************************************** Update Button *********************************************************
    $document.on('click', '#elementor-panel-saver-button-publish', function () {
        if (formWidgetSettings !== null){
            let actions = formWidgetSettings.submit_actions;
            switch (true) {
                case actions.includes('register') :
                    updateOptionValue({
                        'register_user_metas' : getMetaNames(),
                        'manual_verification_email_from_name' : formWidgetSettings['ap_register_manual_verification_email_from_name'],
                        'manual_verification_email_from' : formWidgetSettings['ap_register_manual_verification_email_from'],
                        'manual_verification_email_subject' : formWidgetSettings['ap_register_manual_verification_email_subject'],
                        'manual_verification_email_content_type' : formWidgetSettings['ap_register_manual_verification_email_content_type'],
                        'manual_verification_email_message' : formWidgetSettings['ap_register_manual_verification_email_message'],
                    });
                    break;
                case actions.includes('login') :
                    updateOptionValue({
                        'logout_redirection_url' : formWidgetSettings['ap_login_logout_redirection_url'],
                        'default_login_page_redirection_url' : formWidgetSettings['ap_default_login_page_redirection_url'],
                        'remember_me_duration' : formWidgetSettings['ap_login_remember_me_duration']
                    });
                    break;
            }
        }
    });


//********************************************** OTP Modal *************************************************************
    $document.on("mouseup", '.elementor-control-type-section', function(e) {
        if( $(this).hasClass('elementor-control-ap_register_otp_style') || $(this).hasClass('elementor-control-ap_login_otp_style') || $(this).hasClass('elementor-control-ap_reset_pass_otp_style') ){

            if( $(this).hasClass('elementor-open')){
                $form.find('.ap-otp-container').remove();
            }
            else{
                let otpLength;
                if( formWidgetSettings.submit_actions === 'register' ){
                    otpLength = formWidgetSettings['ap_register_email_otp_length'];
                }else if( formWidgetSettings.submit_actions === 'login' ){
                    otpLength = formWidgetSettings['ap_login_otp_length'];
                }else{
                    otpLength = formWidgetSettings['ap_reset_pass_otp_length'];
                }

                const modal = $iframe.contentWindow.ap_generate_otp_modal(
                    '',
                    {
                        'email' : {
                            'length' : otpLength,
                            'nonce' : ''
                        }
                    },
                    {
                        'email' : {
                            'nonce' : ''
                        }
                    },
                    {
                        'email' : {
                            'nonce' : ''
                        }
                    }
                );
                $form.append(modal);
            }
        }else{
            if( $('.elementor-control-ap_register_otp_style').hasClass('elementor-open') || $('.elementor-control-ap_login_otp_style').hasClass('elementor-open') ){
                $form.find('.ap-otp-container').remove();
            }
        }
    });
    $document.on("mouseup", '.elementor-tab-control-content', function(e) {
        if( $('.elementor-control-ap_register_otp_style').hasClass('elementor-open') || $('.elementor-control-ap_login_otp_style').hasClass('elementor-open') || $('.elementor-control-ap_reset_pass_otp_style').hasClass('elementor-open') ){
            $form.find('.ap-otp-container').remove();
        }
    });
    $document.on("mouseup", '.elementor-tab-control-advanced', function(e) {
        if( $('.elementor-control-ap_register_otp_style').hasClass('elementor-open') || $('.elementor-control-ap_login_otp_style').hasClass('elementor-open') || $('.elementor-control-ap_reset_pass_otp_style').hasClass('elementor-open') ){
            $form.find('.ap-otp-container').remove();
        }
    });
    $document.on("change", '.elementor-tab-control-advanced', function(e) {
        if( $('.elementor-control-ap_register_otp_style').hasClass('elementor-open') || $('.elementor-control-ap_login_otp_style').hasClass('elementor-open') || $('.elementor-control-ap_reset_pass_otp_style').hasClass('elementor-open') ){
            $form.find('.ap-otp-container').remove();
        }
    });


//******************************************** Populate SELECT fields on FORM FIELD events ( Common for all )***********
    // Update select options when something happens on FORM FIELD CUSTOM ID field
    $document.on('change', '.elementor-control-custom_id input', function() {
        updateFormFieldsSelect();
    });
    // Update select options when something happens on FORM FIELD REPEATER field
    $document.on('click', '.elementor-control-form_fields .elementor-repeater-add', function() {
        updateFormFieldsSelect();
    });
    $document.on('mouseup', '.elementor-control-form_fields .elementor-repeater-row-tool', function() {
        updateFormFieldsSelect();
    });


//************************************************ REGISTER ************************************************************
    // Update all single fields
    $document.on('mouseup', '.elementor-control-ap_section_register', function() {
        updateFormFieldsSelect('.elementor-control-ap_register_username select');
        updateFormFieldsSelect('.elementor-control-ap_register_password select');
        updateFormFieldsSelect('.elementor-control-ap_register_password_confirm select');
        updateFormFieldsSelect('.elementor-control-ap_register_user_email select');
        updateFormFieldsSelect('.elementor-control-ap_register_user_phone select');
        updateFormFieldsSelect('.elementor-control-ap_register_additional_form_field select', 'ap_user_additional_fields');
    });

    // Update select options when something happens on USER EXTRA REPEATER field
    $document.on('click', '.elementor-control-ap_user_additional_fields .elementor-repeater-add', function() {
        updateFormFieldsSelect('.elementor-control-ap_register_additional_form_field select', 'ap_user_additional_fields');
    });
    $document.on('mouseup', '.elementor-control-ap_user_additional_fields .elementor-repeater-tool-duplicate', function() {
        updateFormFieldsSelect('.elementor-control-ap_register_additional_form_field select', 'ap_user_additional_fields');
    });


//************************************************ LOGIN ***************************************************************
    // Update all single fields
    $document.on('mouseup', '.elementor-control-ap_section_login', function() {
        updateFormFieldsSelect('.elementor-control-ap_login_user select');
        updateFormFieldsSelect('.elementor-control-ap_login_password select');
        updateFormFieldsSelect('.elementor-control-ap_login_remember_me select');
    });

//************************************************ RESET PASSWORD ***************************************************************
    // Update all single fields
    $document.on('mouseup', '.elementor-control-ap_section_reset_pass', function() {
        updateFormFieldsSelect('.elementor-control-ap_reset_pass_login_id select');
        updateFormFieldsSelect('.elementor-control-ap_reset_pass_new_password select');
    });

//************************************************ EDIT PROFILE ***************************************************************
    // Update all single fields
    $document.on('mouseup', '.elementor-control-ap_section_profile', function() {
        updateFormFieldsSelect('.elementor-control-ap_profile_form_field select', 'ap_profile_fields');
    });

    // Update select options when something happens on USER EXTRA REPEATER field
    $document.on('click', '.elementor-control-ap_profile_fields .elementor-repeater-add', function() {
        updateFormFieldsSelect('.elementor-control-ap_profile_form_field select', 'ap_profile_fields');
    });
    $document.on('mouseup', '.elementor-control-ap_profile_fields .elementor-repeater-tool-duplicate', function() {
        updateFormFieldsSelect('.elementor-control-ap_profile_form_field select', 'ap_profile_fields');
    });

//************************************************ Google Sheet ***************************************************************
    let default_options = '<option value="meta">Meta Data</option>';

    // Update all single fields when clicked on SECTION
    $document.on('mouseup', '.elementor-control-ap_section_google_sheet', function() {
        updateFormFieldsSelect('.elementor-control-ap_google_sheet_form_field select', 'ap_google_sheet_mapping', default_options);
    });

    // Update select options when something happens on REPEATER field
    $document.on('click', '.elementor-control-ap_google_sheet_mapping .elementor-repeater-add', function() {
        updateFormFieldsSelect('.elementor-control-ap_google_sheet_form_field select', 'ap_google_sheet_mapping', default_options);
    });

    // Update when drag and drop or clicked on delete or duplicate
    $document.on('mouseup', '.elementor-control-ap_google_sheet_mapping .elementor-repeater-row-tools', function(e) {
        updateFormFieldsSelect('.elementor-control-ap_google_sheet_form_field select', 'ap_google_sheet_mapping', default_options);
    });

//************************************************ FUNCTIONS ***********************************************************

    // Populate Select Field
    function updateFormFieldsSelect(section_input = '', section_name = '', default_options= '') {
        // wait until elementor do its things
        setTimeout(function(){
            if (formWidgetSettings) {

                let fields = formWidgetSettings['form_fields'];
                let options = '<option value="" selected></option>' + default_options; // <option value="" selected>--select--</option>
                let item = 0;

                $(fields.models).each(function(index,element){
                    if( element.attributes.field_label !== ''){
                        item++;
                        options += '<option value="'+element.attributes.custom_id+'">'+element.attributes.field_label+'</option>';
                    }else {
                        item++;
                        options += '<option value="'+element.attributes.custom_id+'">'+'Item #'+item+'</option>';
                    }
                });

                $(fields.models).each(function(index,element){
                    var custom_id_input = false;
                    $(".elementor-control-custom_id input").each(function(index,input){
                        if ($(this).val() === element.attributes.custom_id) {
                            custom_id_input = $(this);
                        }
                    });

                    if (section_input) {

                        // custom field selector
                        let select = $(section_input).first();

                        if (select) {
                            if (select.closest('.elementor-control-type-repeater').length) {

                                if (select.closest('.elementor-control-type-repeater').hasClass('elementor-control-'+section_name)) {
                                    // in repeater
                                    $(section_input).each(function(index, select){
                                        let data_setting = $(this).attr('data-setting');
                                        let ids = formWidgetSettings[section_name]['models'][index]['attributes'][data_setting];
                                        if( typeof ids !== 'undefined'){
                                            updateFormSelect($(this), options, ids, custom_id_input);
                                        }
                                    });
                                }
                            } else {
                                // single field
                                let data_setting = select.data('setting');
                                let ids = formWidgetSettings[data_setting];
                                if( typeof ids !== 'undefined'){
                                    updateFormSelect(select, options, ids, custom_id_input);
                                }
                            }
                        }
                    }
                });
            }
        }, 1000);
    }
    function updateFormSelect(select, options, ids, custom_id_input) {
        if (select) {
            let is_select2 = false;
            if (select.hasClass("select2-hidden-accessible")) {
                // Select2 has been initialized
                select.select2('destroy');
                is_select2 = true;
            }
            select.html(options);
            if (custom_id_input) {
                // remove itself
                select.find("option[value='"+custom_id_input.val()+"']").remove();
            }
            select.val(ids);
            if (is_select2) {
                // Select2 has been initialized
                select.select2();
            }
        }
    }

    // Return a string containing meta names separated by commas
    function getMetaNames(){
        let metas = [];

        if(formWidgetSettings['ap_register_phone_popover'] === 'yes' && formWidgetSettings['ap_register_user_phone'] !== ''){
            metas.push('user_phone');
        }

        if(formWidgetSettings['ap_register_email_popover'] === 'yes' && formWidgetSettings['ap_register_enable_email_verification'] === 'yes'){
            metas.push('is_email_verified');
        }

        if(formWidgetSettings['ap_register_phone_popover'] === 'yes' && formWidgetSettings['ap_register_enable_phone_verification'] === 'yes'){
            metas.push('is_phone_verified');
        }

        if(formWidgetSettings['ap_register_manual_verification_popover'] === 'yes' && formWidgetSettings['ap_register_enable_manual_verification'] === 'yes'){
            metas.push('is_manually_verified');
        }

        $(formWidgetSettings['ap_user_additional_fields'].models).each(function(index,element){
            if (element.attributes.ap_register_additional_user_field !== ''){
                if( element.attributes.ap_register_additional_user_field === 'custom' ){
                    if(element.attributes.ap_register_additional_user_field_custom !== ''){
                        metas.push(element.attributes.ap_register_additional_user_field_custom);
                    }
                }
                else{
                    metas.push(element.attributes.ap_register_additional_user_field);
                }
            }
        });

        return [...new Set(metas)].join();
    }

    // Update any value in Option table From inside Elementor Editor
    // TODO: Nonce implement
    function updateOptionValue( optionValuePairs) {
        $.ajax({
            url: ajaxurl,
            type: 'post',
            dataType: 'json',
            data: {
                action: 'ap_update_option_value',
                optionValuePairs : optionValuePairs
            }
        });
    }
})(jQuery);
