(function( $, wp ) {

    let $document = $(document);
    let inputs = {};
    let verificationCompleted = {};
    let data;

    const { __ } = wp.i18n;

    // Performance
    // let t0, t1;
    // $('.elementor-button').on('click',function () {
    //     t0 = performance.now();
    // });

    // Modal Trigger
    $document.ajaxSuccess(function( event, request, settings, response ) {

        // t1 = performance.now();
        // console.log((( t1 - t0)/1000).toFixed(2) + " seconds");
        // console.log(response);

        if ( response.data && response.data.data){

            // Registration
            if( response.data.data.apRegistrationSuccess ){
                data = response.data.data.apRegistrationSuccess;

                // Generate otp modal by populating all data and append
                if(data.verifyChannels){
                    let modal = ap_generate_otp_modal( data.username, data.verifyChannels, data.notifyChannels, data.updateChannels );
                    $('[data-id="'+data.formId+'"]').append(modal);
                }

                // Send notification
                if(data.notifyChannels){
                    $.each(data.notifyChannels, function (channel) {
                        ap_execute_user_ajax_operations('notify_' + channel, data.notifyChannels[channel].nonce, data.username, channel, '','','', '');
                    })
                }

                // Update User Fields
                if(data.updateFields){
                    ap_execute_user_ajax_operations('update_fields',  data.updateFields.nonce, data.username, '')
                }


                // Redirect instantly. Return if there is a OTP Modal
                if(data.redirectTo){
                    if( data.verifyChannels ){
                        return;
                    }
                    $('[data-id="'+data.formId+'"] .ap-otp-box').append('<p><i class="fas fa-spinner fa-spin dashicons dashicons-update spin"></i>&nbsp;'+__('Redirecting...', 'actions-pack')+'</p>')
                    location.href = data.redirectTo;
                }
            }

            // Login
            if( response.data.data.apLoginViaOtp ){
                data = response.data.data.apLoginViaOtp;

                let modal = ap_generate_otp_modal_login( data.username, data.nonce, data.otpLength, data.notifyChannels, data.remember, 'login' );
                $('.ap-otp-container').remove();
                $('[data-id="'+data.formId+'"]').append(modal);

                // Send OTP to all Channels
                $.each(data.notifyChannels, function (channel) {
                    ap_execute_login_ajax_operations('notify_' + channel, data.notifyChannels[channel].nonce, data.username, channel, '','','', '');
                });
            }

            // Reset Pass
            if( response.data.data.apResetPass ){
                data = response.data.data.apResetPass;

                if( data.otpLength ){
                    let modal = ap_generate_otp_modal_login( data.username, data.nonce, data.otpLength, data.notifyChannels, false, 'reset');
                    $('.ap-otp-container').remove();
                    $('[data-id="'+data.formId+'"]').append(modal);
                }

                // Send Reset Link/OTP to all Channels
                $.each(data.notifyChannels, function (channel) {
                    ap_execute_reset_pass_ajax_operations('notify_' + channel, data.notifyChannels[channel].nonce, data.username, channel, '','','');
                });

            }

            // Edit Profile
            if( response.data.data.apProfileChanges ){
                data = response.data.data.apProfileChanges;
                let $formWrapper = $('[data-id="'+data.form_id+'"]');
                $formWrapper.find('.elementor-alert').remove()
                if( data.user_pending_message || data.admin_pending_message ){
                    let $form = $formWrapper.find('form');
                    if( data.user_pending_message ){
                        $form.before(ap_generate_alert_html('warning', '', data.user_pending_message))
                    }
                    if( data.admin_pending_message ){
                        $form.before(ap_generate_alert_html('warning', '', data.admin_pending_message))
                    }
                    $.ajax({
                        url: apUser.ajaxUrl,
                        type: 'post',
                        dataType: 'json',
                        data:{
                            action: 'ap_notify_data_changes',
                            nonce: data.nonce,
                            username: data.username,
                            post_id: data.post_id,
                            form_id: data.form_id,
                            referrer: window.location.href
                        }
                    });
                }
            }
        }

        // Redirect when all otp verification completed
        if( ! $.isEmptyObject(verificationCompleted) && Object.keys(verificationCompleted).every((k) => verificationCompleted[k]) ){
            if( data && data.redirectTo ){
                $('[data-id="'+data.formId+'"] .ap-otp-box').append('<p><i class="fas fa-spinner fa-spin dashicons dashicons-update spin"></i>&nbsp;'+__('Redirecting...', 'actions-pack')+'</p>')
                location.href = data.redirectTo;
            }
            else if($('body').hasClass('wp-core-ui')){
                $('.ap-otp-box').append('<p><i class="fas fa-spinner fa-spin dashicons dashicons-update spin"></i>&nbsp;'+__('Redirecting...', 'actions-pack')+'</p>');
                location.reload();
            }
        }

    });

    // Modal Trigger
    $document.on('click', '.ap-otp-modal-trigger', function () {
        if( $('body').find('.ap-otp-container').length === 0 ){
            let data = JSON.parse( decodeURIComponent($(this).data('ajax') ) );
            console.log(data);
            let modal = ap_generate_otp_modal( data.username, data.verifyChannels, data.notifyChannels, data.updateChannels );
            $(this).closest('div').after(modal);
        }
    });

    $document.on('click', '.ap-otp-resend-code', function () {
        let $this = $(this);
        let username = $this.data('username');
        let nonce = $this.data('nonce');
        let channel = $this.data('channel');

        let before_send = function(){
            $this.prop('disabled', true);
            $this.html('<i class="fas fa-spinner fa-spin dashicons dashicons-update spin"></i>&nbsp;'+ __('Sending...', 'actions-pack'));
        }
        let on_success = function(response){
            if( response.success === true){
                $this.html('<i class="fas fa-check-circle dashicons dashicons-yes-alt"></i>&nbsp;'+ response.data);
            }
            else{
                $this.html('<i class="fas fa-times-circle dashicons dashicons-dismiss"></i>&nbsp;'+ response.data);
            }
        }

        ap_execute_user_ajax_operations('notify_' + channel, nonce, username, channel,'', '', before_send, on_success)
    })

    $document.on('click', '.ap-otp-change-channel', function () {
        let $this = $(this);
        let $input = $this.parents('.ap-otp-actions').next();
        $input.toggleClass('ap-active');

        if( $this.prev().data('channel') !== 'email' && $input.find('select').length === 0){
            let jsonData = {
                "countries": [
                    {
                        "code": "+7 840",
                        "name": "Abkhazia"
                    },
                    {
                        "code": "+93",
                        "name": "Afghanistan"
                    },
                    {
                        "code": "+355",
                        "name": "Albania"
                    },
                    {
                        "code": "+213",
                        "name": "Algeria"
                    },
                    {
                        "code": "+1 684",
                        "name": "American Samoa"
                    },
                    {
                        "code": "+376",
                        "name": "Andorra"
                    },
                    {
                        "code": "+244",
                        "name": "Angola"
                    },
                    {
                        "code": "+1 264",
                        "name": "Anguilla"
                    },
                    {
                        "code": "+1 268",
                        "name": "Antigua and Barbuda"
                    },
                    {
                        "code": "+54",
                        "name": "Argentina"
                    },
                    {
                        "code": "+374",
                        "name": "Armenia"
                    },
                    {
                        "code": "+297",
                        "name": "Aruba"
                    },
                    {
                        "code": "+247",
                        "name": "Ascension"
                    },
                    {
                        "code": "+61",
                        "name": "Australia"
                    },
                    {
                        "code": "+672",
                        "name": "Australian External Territories"
                    },
                    {
                        "code": "+43",
                        "name": "Austria"
                    },
                    {
                        "code": "+994",
                        "name": "Azerbaijan"
                    },
                    {
                        "code": "+1 242",
                        "name": "Bahamas"
                    },
                    {
                        "code": "+973",
                        "name": "Bahrain"
                    },
                    {
                        "code": "+880",
                        "name": "Bangladesh"
                    },
                    {
                        "code": "+1 246",
                        "name": "Barbados"
                    },
                    {
                        "code": "+1 268",
                        "name": "Barbuda"
                    },
                    {
                        "code": "+375",
                        "name": "Belarus"
                    },
                    {
                        "code": "+32",
                        "name": "Belgium"
                    },
                    {
                        "code": "+501",
                        "name": "Belize"
                    },
                    {
                        "code": "+229",
                        "name": "Benin"
                    },
                    {
                        "code": "+1 441",
                        "name": "Bermuda"
                    },
                    {
                        "code": "+975",
                        "name": "Bhutan"
                    },
                    {
                        "code": "+591",
                        "name": "Bolivia"
                    },
                    {
                        "code": "+387",
                        "name": "Bosnia and Herzegovina"
                    },
                    {
                        "code": "+267",
                        "name": "Botswana"
                    },
                    {
                        "code": "+55",
                        "name": "Brazil"
                    },
                    {
                        "code": "+246",
                        "name": "British Indian Ocean Territory"
                    },
                    {
                        "code": "+1 284",
                        "name": "British Virgin Islands"
                    },
                    {
                        "code": "+673",
                        "name": "Brunei"
                    },
                    {
                        "code": "+359",
                        "name": "Bulgaria"
                    },
                    {
                        "code": "+226",
                        "name": "Burkina Faso"
                    },
                    {
                        "code": "+257",
                        "name": "Burundi"
                    },
                    {
                        "code": "+855",
                        "name": "Cambodia"
                    },
                    {
                        "code": "+237",
                        "name": "Cameroon"
                    },
                    {
                        "code": "+1",
                        "name": "Canada"
                    },
                    {
                        "code": "+238",
                        "name": "Cape Verde"
                    },
                    {
                        "code": "+ 345",
                        "name": "Cayman Islands"
                    },
                    {
                        "code": "+236",
                        "name": "Central African Republic"
                    },
                    {
                        "code": "+235",
                        "name": "Chad"
                    },
                    {
                        "code": "+56",
                        "name": "Chile"
                    },
                    {
                        "code": "+86",
                        "name": "China"
                    },
                    {
                        "code": "+61",
                        "name": "Christmas Island"
                    },
                    {
                        "code": "+61",
                        "name": "Cocos-Keeling Islands"
                    },
                    {
                        "code": "+57",
                        "name": "Colombia"
                    },
                    {
                        "code": "+269",
                        "name": "Comoros"
                    },
                    {
                        "code": "+242",
                        "name": "Congo"
                    },
                    {
                        "code": "+243",
                        "name": "Congo, Dem. Rep. of (Zaire)"
                    },
                    {
                        "code": "+682",
                        "name": "Cook Islands"
                    },
                    {
                        "code": "+506",
                        "name": "Costa Rica"
                    },
                    {
                        "code": "+385",
                        "name": "Croatia"
                    },
                    {
                        "code": "+53",
                        "name": "Cuba"
                    },
                    {
                        "code": "+599",
                        "name": "Curacao"
                    },
                    {
                        "code": "+537",
                        "name": "Cyprus"
                    },
                    {
                        "code": "+420",
                        "name": "Czech Republic"
                    },
                    {
                        "code": "+45",
                        "name": "Denmark"
                    },
                    {
                        "code": "+246",
                        "name": "Diego Garcia"
                    },
                    {
                        "code": "+253",
                        "name": "Djibouti"
                    },
                    {
                        "code": "+1 767",
                        "name": "Dominica"
                    },
                    {
                        "code": "+1 809",
                        "name": "Dominican Republic"
                    },
                    {
                        "code": "+670",
                        "name": "East Timor"
                    },
                    {
                        "code": "+56",
                        "name": "Easter Island"
                    },
                    {
                        "code": "+593",
                        "name": "Ecuador"
                    },
                    {
                        "code": "+20",
                        "name": "Egypt"
                    },
                    {
                        "code": "+503",
                        "name": "El Salvador"
                    },
                    {
                        "code": "+240",
                        "name": "Equatorial Guinea"
                    },
                    {
                        "code": "+291",
                        "name": "Eritrea"
                    },
                    {
                        "code": "+372",
                        "name": "Estonia"
                    },
                    {
                        "code": "+251",
                        "name": "Ethiopia"
                    },
                    {
                        "code": "+500",
                        "name": "Falkland Islands"
                    },
                    {
                        "code": "+298",
                        "name": "Faroe Islands"
                    },
                    {
                        "code": "+679",
                        "name": "Fiji"
                    },
                    {
                        "code": "+358",
                        "name": "Finland"
                    },
                    {
                        "code": "+33",
                        "name": "France"
                    },
                    {
                        "code": "+596",
                        "name": "French Antilles"
                    },
                    {
                        "code": "+594",
                        "name": "French Guiana"
                    },
                    {
                        "code": "+689",
                        "name": "French Polynesia"
                    },
                    {
                        "code": "+241",
                        "name": "Gabon"
                    },
                    {
                        "code": "+220",
                        "name": "Gambia"
                    },
                    {
                        "code": "+995",
                        "name": "Georgia"
                    },
                    {
                        "code": "+49",
                        "name": "Germany"
                    },
                    {
                        "code": "+233",
                        "name": "Ghana"
                    },
                    {
                        "code": "+350",
                        "name": "Gibraltar"
                    },
                    {
                        "code": "+30",
                        "name": "Greece"
                    },
                    {
                        "code": "+299",
                        "name": "Greenland"
                    },
                    {
                        "code": "+1 473",
                        "name": "Grenada"
                    },
                    {
                        "code": "+590",
                        "name": "Guadeloupe"
                    },
                    {
                        "code": "+1 671",
                        "name": "Guam"
                    },
                    {
                        "code": "+502",
                        "name": "Guatemala"
                    },
                    {
                        "code": "+224",
                        "name": "Guinea"
                    },
                    {
                        "code": "+245",
                        "name": "Guinea-Bissau"
                    },
                    {
                        "code": "+595",
                        "name": "Guyana"
                    },
                    {
                        "code": "+509",
                        "name": "Haiti"
                    },
                    {
                        "code": "+504",
                        "name": "Honduras"
                    },
                    {
                        "code": "+852",
                        "name": "Hong Kong SAR China"
                    },
                    {
                        "code": "+36",
                        "name": "Hungary"
                    },
                    {
                        "code": "+354",
                        "name": "Iceland"
                    },
                    {
                        "code": "+91",
                        "name": "India"
                    },
                    {
                        "code": "+62",
                        "name": "Indonesia"
                    },
                    {
                        "code": "+98",
                        "name": "Iran"
                    },
                    {
                        "code": "+964",
                        "name": "Iraq"
                    },
                    {
                        "code": "+353",
                        "name": "Ireland"
                    },
                    {
                        "code": "+972",
                        "name": "Israel"
                    },
                    {
                        "code": "+39",
                        "name": "Italy"
                    },
                    {
                        "code": "+225",
                        "name": "Ivory Coast"
                    },
                    {
                        "code": "+1 876",
                        "name": "Jamaica"
                    },
                    {
                        "code": "+81",
                        "name": "Japan"
                    },
                    {
                        "code": "+962",
                        "name": "Jordan"
                    },
                    {
                        "code": "+7 7",
                        "name": "Kazakhstan"
                    },
                    {
                        "code": "+254",
                        "name": "Kenya"
                    },
                    {
                        "code": "+686",
                        "name": "Kiribati"
                    },
                    {
                        "code": "+965",
                        "name": "Kuwait"
                    },
                    {
                        "code": "+996",
                        "name": "Kyrgyzstan"
                    },
                    {
                        "code": "+856",
                        "name": "Laos"
                    },
                    {
                        "code": "+371",
                        "name": "Latvia"
                    },
                    {
                        "code": "+961",
                        "name": "Lebanon"
                    },
                    {
                        "code": "+266",
                        "name": "Lesotho"
                    },
                    {
                        "code": "+231",
                        "name": "Liberia"
                    },
                    {
                        "code": "+218",
                        "name": "Libya"
                    },
                    {
                        "code": "+423",
                        "name": "Liechtenstein"
                    },
                    {
                        "code": "+370",
                        "name": "Lithuania"
                    },
                    {
                        "code": "+352",
                        "name": "Luxembourg"
                    },
                    {
                        "code": "+853",
                        "name": "Macau SAR China"
                    },
                    {
                        "code": "+389",
                        "name": "Macedonia"
                    },
                    {
                        "code": "+261",
                        "name": "Madagascar"
                    },
                    {
                        "code": "+265",
                        "name": "Malawi"
                    },
                    {
                        "code": "+60",
                        "name": "Malaysia"
                    },
                    {
                        "code": "+960",
                        "name": "Maldives"
                    },
                    {
                        "code": "+223",
                        "name": "Mali"
                    },
                    {
                        "code": "+356",
                        "name": "Malta"
                    },
                    {
                        "code": "+692",
                        "name": "Marshall Islands"
                    },
                    {
                        "code": "+596",
                        "name": "Martinique"
                    },
                    {
                        "code": "+222",
                        "name": "Mauritania"
                    },
                    {
                        "code": "+230",
                        "name": "Mauritius"
                    },
                    {
                        "code": "+262",
                        "name": "Mayotte"
                    },
                    {
                        "code": "+52",
                        "name": "Mexico"
                    },
                    {
                        "code": "+691",
                        "name": "Micronesia"
                    },
                    {
                        "code": "+1 808",
                        "name": "Midway Island"
                    },
                    {
                        "code": "+373",
                        "name": "Moldova"
                    },
                    {
                        "code": "+377",
                        "name": "Monaco"
                    },
                    {
                        "code": "+976",
                        "name": "Mongolia"
                    },
                    {
                        "code": "+382",
                        "name": "Montenegro"
                    },
                    {
                        "code": "+1664",
                        "name": "Montserrat"
                    },
                    {
                        "code": "+212",
                        "name": "Morocco"
                    },
                    {
                        "code": "+95",
                        "name": "Myanmar"
                    },
                    {
                        "code": "+264",
                        "name": "Namibia"
                    },
                    {
                        "code": "+674",
                        "name": "Nauru"
                    },
                    {
                        "code": "+977",
                        "name": "Nepal"
                    },
                    {
                        "code": "+31",
                        "name": "Netherlands"
                    },
                    {
                        "code": "+599",
                        "name": "Netherlands Antilles"
                    },
                    {
                        "code": "+1 869",
                        "name": "Nevis"
                    },
                    {
                        "code": "+687",
                        "name": "New Caledonia"
                    },
                    {
                        "code": "+64",
                        "name": "New Zealand"
                    },
                    {
                        "code": "+505",
                        "name": "Nicaragua"
                    },
                    {
                        "code": "+227",
                        "name": "Niger"
                    },
                    {
                        "code": "+234",
                        "name": "Nigeria"
                    },
                    {
                        "code": "+683",
                        "name": "Niue"
                    },
                    {
                        "code": "+672",
                        "name": "Norfolk Island"
                    },
                    {
                        "code": "+850",
                        "name": "North Korea"
                    },
                    {
                        "code": "+1 670",
                        "name": "Northern Mariana Islands"
                    },
                    {
                        "code": "+47",
                        "name": "Norway"
                    },
                    {
                        "code": "+968",
                        "name": "Oman"
                    },
                    {
                        "code": "+92",
                        "name": "Pakistan"
                    },
                    {
                        "code": "+680",
                        "name": "Palau"
                    },
                    {
                        "code": "+970",
                        "name": "Palestinian Territory"
                    },
                    {
                        "code": "+507",
                        "name": "Panama"
                    },
                    {
                        "code": "+675",
                        "name": "Papua New Guinea"
                    },
                    {
                        "code": "+595",
                        "name": "Paraguay"
                    },
                    {
                        "code": "+51",
                        "name": "Peru"
                    },
                    {
                        "code": "+63",
                        "name": "Philippines"
                    },
                    {
                        "code": "+48",
                        "name": "Poland"
                    },
                    {
                        "code": "+351",
                        "name": "Portugal"
                    },
                    {
                        "code": "+1 787",
                        "name": "Puerto Rico"
                    },
                    {
                        "code": "+974",
                        "name": "Qatar"
                    },
                    {
                        "code": "+262",
                        "name": "Reunion"
                    },
                    {
                        "code": "+40",
                        "name": "Romania"
                    },
                    {
                        "code": "+7",
                        "name": "Russia"
                    },
                    {
                        "code": "+250",
                        "name": "Rwanda"
                    },
                    {
                        "code": "+685",
                        "name": "Samoa"
                    },
                    {
                        "code": "+378",
                        "name": "San Marino"
                    },
                    {
                        "code": "+966",
                        "name": "Saudi Arabia"
                    },
                    {
                        "code": "+221",
                        "name": "Senegal"
                    },
                    {
                        "code": "+381",
                        "name": "Serbia"
                    },
                    {
                        "code": "+248",
                        "name": "Seychelles"
                    },
                    {
                        "code": "+232",
                        "name": "Sierra Leone"
                    },
                    {
                        "code": "+65",
                        "name": "Singapore"
                    },
                    {
                        "code": "+421",
                        "name": "Slovakia"
                    },
                    {
                        "code": "+386",
                        "name": "Slovenia"
                    },
                    {
                        "code": "+677",
                        "name": "Solomon Islands"
                    },
                    {
                        "code": "+27",
                        "name": "South Africa"
                    },
                    {
                        "code": "+500",
                        "name": "South Georgia and the South Sandwich Islands"
                    },
                    {
                        "code": "+82",
                        "name": "South Korea"
                    },
                    {
                        "code": "+34",
                        "name": "Spain"
                    },
                    {
                        "code": "+94",
                        "name": "Sri Lanka"
                    },
                    {
                        "code": "+249",
                        "name": "Sudan"
                    },
                    {
                        "code": "+597",
                        "name": "Suriname"
                    },
                    {
                        "code": "+268",
                        "name": "Swaziland"
                    },
                    {
                        "code": "+46",
                        "name": "Sweden"
                    },
                    {
                        "code": "+41",
                        "name": "Switzerland"
                    },
                    {
                        "code": "+963",
                        "name": "Syria"
                    },
                    {
                        "code": "+886",
                        "name": "Taiwan"
                    },
                    {
                        "code": "+992",
                        "name": "Tajikistan"
                    },
                    {
                        "code": "+255",
                        "name": "Tanzania"
                    },
                    {
                        "code": "+66",
                        "name": "Thailand"
                    },
                    {
                        "code": "+670",
                        "name": "Timor Leste"
                    },
                    {
                        "code": "+228",
                        "name": "Togo"
                    },
                    {
                        "code": "+690",
                        "name": "Tokelau"
                    },
                    {
                        "code": "+676",
                        "name": "Tonga"
                    },
                    {
                        "code": "+1 868",
                        "name": "Trinidad and Tobago"
                    },
                    {
                        "code": "+216",
                        "name": "Tunisia"
                    },
                    {
                        "code": "+90",
                        "name": "Turkey"
                    },
                    {
                        "code": "+993",
                        "name": "Turkmenistan"
                    },
                    {
                        "code": "+1 649",
                        "name": "Turks and Caicos Islands"
                    },
                    {
                        "code": "+688",
                        "name": "Tuvalu"
                    },
                    {
                        "code": "+1 340",
                        "name": "U.S. Virgin Islands"
                    },
                    {
                        "code": "+256",
                        "name": "Uganda"
                    },
                    {
                        "code": "+380",
                        "name": "Ukraine"
                    },
                    {
                        "code": "+971",
                        "name": "United Arab Emirates"
                    },
                    {
                        "code": "+44",
                        "name": "United Kingdom"
                    },
                    {
                        "code": "+1",
                        "name": "United States"
                    },
                    {
                        "code": "+598",
                        "name": "Uruguay"
                    },
                    {
                        "code": "+998",
                        "name": "Uzbekistan"
                    },
                    {
                        "code": "+678",
                        "name": "Vanuatu"
                    },
                    {
                        "code": "+58",
                        "name": "Venezuela"
                    },
                    {
                        "code": "+84",
                        "name": "Vietnam"
                    },
                    {
                        "code": "+1 808",
                        "name": "Wake Island"
                    },
                    {
                        "code": "+681",
                        "name": "Wallis and Futuna"
                    },
                    {
                        "code": "+967",
                        "name": "Yemen"
                    },
                    {
                        "code": "+260",
                        "name": "Zambia"
                    },
                    {
                        "code": "+255",
                        "name": "Zanzibar"
                    },
                    {
                        "code": "+263",
                        "name": "Zimbabwe"
                    }
                ]
            };
            let listItems = '';
            for (let i = 0; i < jsonData.countries.length; i++) {
                listItems += "<option value='" + jsonData.countries[i].code + "'>" + jsonData.countries[i].name + ' (' + jsonData.countries[i].code + ')' + "</option>";
            }
            $input.prepend('<select class="ap-country-code">' + listItems + '</select>');
        }
    })

    $document.on('click', '.ap-otp-update-channel button', function ( e ) {
        let $this = $(this);
        let channel = $this.data('channel');
        let username = $this.data('username');
        let nonce = $this.data('nonce');
        let channelValue = $this.prev().val();
        if( channel === 'phone'){
            let countryCode = $this.prev().prev().find(':selected').val();
            channelValue = countryCode + channelValue;
        }
        let before_send = function (){
            $this.prop('disabled', true);
            $this.html('<i class="fas fa-spinner fa-spin dashicons dashicons-update spin"></i>&nbsp;'+ __('Updating', 'actions-pack'));
        }
        let on_success = function(response){
            if( response.success === true){
                $this.html('<i class="fas fa-check-circle dashicons dashicons-yes-alt"></i>&nbsp;'+ response.data);
                $this.prev().prop('disabled', true);
                setTimeout(function() {
                    $this.parents('.ap-otp-update-channel').removeClass('ap-active');
                }, 500);
            }
            else{
                $this.html('<i class="fas fa-times-circle dashicons dashicons-dismiss"></i>&nbsp;Try Again');
                $this.prev().val(response.data);
                $this.prop('disabled', false);
            }
        }
        channelValue = channelValue.replace(/ /g,'');
        ap_execute_user_ajax_operations( 'update_' + channel, nonce, username, channel, '', channelValue, before_send, on_success)
    })

    // Generate OTP Modal
    window.ap_generate_otp_modal = function ( username, otp, notify, update){

        let modal = '<div class="ap-otp-container"><div class="ap-otp-box">';

        $.each(otp, function ( channel) {
            modal += '<div class="ap-otp-channel" data-channel="' + channel + '">';
            modal += '<div class="ap-otp-heading">';
            modal += '<p>' + __( 'Enter the ', 'actions-pack') + otp[channel].length + __(' digits code sent to your ', 'actions-pack') + '<strong>' + channel +'</strong></p></div>';
            modal += '<div class="ap-otp-inputs" data-username="' + username + '" data-channel="' + channel + '" data-nonce="' + otp[channel].nonce + '" data-length="'+ otp[channel].length + '" data-form="registration">';
            for ( let i = 0; i < otp[channel].length ; i++) {
                modal += '<input class="ap-otp-input" type="tel" maxlength="1" data-index="' + i + '">';
            }
            modal += '</div>'
            modal += '<div class="ap-otp-actions"><p><a href="javascript:void(0)" class="ap-otp-resend-code" data-nonce="'+ notify[channel].nonce +'" data-username="'+username+'" data-channel="'+channel+'">'+__('Resend code', 'actions-pack')+'</a>&nbsp;|&nbsp;<a href="javascript:void(0)" class="ap-otp-change-channel">' + __('Change ', 'actions-pack') + channel +'</a></p></div>';
            modal += '<div class="ap-otp-update-channel"><input class="ap-channel-input" type="tel" placeholder="'+ __('Enter your ') + channel + '"><button data-nonce="'+ update[channel].nonce +'" data-username="'+username+'" data-channel="'+channel+'" type="button">Update</button></div>';
            modal += '</div>';
            verificationCompleted[channel] = false;
        });
        modal += '</div></div>';
        return modal;
    }

    // Generate OTP Modal (Login)
    window.ap_generate_otp_modal_login = function ( username, nonce, otpLength, notify, remember, form){

        let modal = '<div class="ap-otp-container"><div class="ap-otp-box">';

        modal += '<div class="ap-otp-channel">';
        modal += '<div class="ap-otp-heading">';

        let otpChannels = [];
        let i = 0;
        $.each(notify, function (channel) {
            otpChannels[i] = channel;
            i++
        })

        modal += '<p>' + __( 'Enter the ', 'actions-pack') + otpLength + __(' digits code sent to your ', 'actions-pack') + otpChannels.join(' & ') + '</strong></p></div>';
        modal += '<div class="ap-otp-inputs" data-channel="otp" data-username="' + username + '" data-nonce="' + nonce + '" data-length="'+ otpLength + '" data-form="' + form + '" data-remember="' + remember +'">';
        for ( let i = 0; i < otpLength ; i++) {
            modal += '<input class="ap-otp-input" type="tel" maxlength="1" data-index="' + i + '">';
        }
        modal += '</div>'
        modal += '</div>';
        verificationCompleted['otp'] = false;

        modal += '</div></div>';
        return modal;
    }

    // Submit verification code on input
    $document.on('keyup', '.ap-otp-inputs input', function( e ){

        let $input = $(this); // Individual input
        let $inputGroup = $input.closest('.ap-otp-inputs');

        if( e.keyCode === 8 || e.keyCode === 37 ){
            $input.prev(':input').focus();
        }
        else{
            $input.next(':input').focus();
        }

        let channel = $inputGroup.data('channel');
        if (!inputs[channel]){
            inputs[channel] = [];
        }

        if($input.val() !== ''){
            inputs[channel][$input.data("index")] = $input.val();
        }

        let length = $inputGroup.data('length');
        if( inputs[channel].length === length ){
            let username = $inputGroup.data('username');
            let nonce = $inputGroup.data('nonce');
            let before_send = function(){
                $inputGroup.find('input').prop('disabled', true);
                $inputGroup.prev().find('p').html('<i class="fas fa-spinner fa-spin dashicons dashicons-update spin"></i>&nbsp;'+ __('Verifying your ', 'actions-pack') + '<strong>' + channel + '</strong>');
            }
            let on_success = function(response){
                if( response.success === true){
                    $inputGroup.prev().find('p').html('<i class="fas fa-check-circle dashicons dashicons-yes-alt" style="color:#2ec72e"></i>&nbsp;'+ response.data);
                    $inputGroup.hide();
                    $inputGroup.next().hide();
                    verificationCompleted[channel] = true;
                }
                else{
                    $inputGroup.prev().find('p').html('<i class="fas fa-times-circle dashicons dashicons-dismiss" style="color:#dc431c"></i>&nbsp;'+ response.data);
                    $inputGroup.find('input').prop('disabled', false).val('');
                    $inputGroup.find('input:first').focus();
                    startCountdown($('.apCountDown'));
                }
            }
            if($inputGroup.data('form') === 'login' ){
                ap_execute_login_ajax_operations('verify_otp', nonce, username, 'otp', inputs[channel].join(''), $inputGroup.data('remember'), before_send, on_success);
            }
            else if($inputGroup.data('form') === 'reset'){
                let on_success = function(response){
                    if( response.success === true){
                        $inputGroup.prev().find('p').html('<i class="fas fa-check-circle dashicons dashicons-yes-alt" style="color:#2ec72e"></i>&nbsp;'+ response.data.message);
                        $inputGroup.hide();
                        $inputGroup.next().hide();
                        verificationCompleted[channel] = true;
                    }
                    else{
                        $inputGroup.prev().find('p').html('<i class="fas fa-times-circle dashicons dashicons-dismiss" style="color:#dc431c"></i>&nbsp;'+ response.data);
                        $inputGroup.find('input').prop('disabled', false).val('');
                        $inputGroup.find('input:first').focus();
                        startCountdown($('.apCountDown'));
                    }
                }
                ap_execute_reset_pass_ajax_operations('verify_otp', nonce, username, 'otp', inputs[channel].join(''), before_send, on_success);
            }
            else{
                ap_execute_user_ajax_operations('verify_' + channel, nonce, username, channel, inputs[channel].join(''), '', before_send, on_success );
            }
            delete inputs[channel];
        }
    });

    // Do things when DOM/Elementor completely loads.
    // $.ready.promise().done(function(){
    // });

    // TODO: Shift to common.js
    function ap_generate_alert_html(type, title, description){
        return '<div class="elementor-alert elementor-alert-'+ type +'" style="transition:opacity 1s;margin-bottom:15px;" role="alert">\n' +
            '        <span class="elementor-alert-title">'+ title +'</span>\n' +
            '        <span class="elementor-alert-description">'+ description +'</span>\n' +
            '        <button type="button" class="elementor-alert-dismiss" onclick="t=this.parentElement;t.style.opacity=0;t.addEventListener(\'transitionend\',function(){t.remove()})"' +
            '            <span aria-hidden="true">×</span>\n' +
            '            <span class="elementor-screen-only">Dismiss alert</span>\n' +
            '        </button>\n' +
            '    </div>';
    }

    // Execute Ajax Operation @toDO rename
    function ap_execute_user_ajax_operations( operation, nonce, username, channel = '', otp = '', channelValue='', before_send ='', on_success='') {
        $.ajax({
            url: apUser.ajaxUrl,
            type: 'post',
            dataType: 'json',
            data:{
                action: 'ap_execute_user_ajax_operations',
                operation: operation,
                channel: channel,
                nonce: nonce,
                username: username,
                otp: otp,
                channelValue: channelValue,
                referrer: window.location.href
            },
            beforeSend: before_send,
            success: on_success,
        });
    }

    function ap_execute_login_ajax_operations( operation, operation_nonce, username, channel = '', otp = '', remember, before_send ='', on_success='') {
        $.ajax({
            url: apUser.ajaxUrl,
            type: 'post',
            dataType: 'json',
            data:{
                action: 'ap_execute_login_ajax_operations',
                operation: operation,
                channel: channel,
                nonce: operation_nonce,
                username: username,
                otp: otp,
                remember: remember,
                postId: data.postId,
                formId: data.formId,
                referrer: window.location.href
            },
            beforeSend: before_send,
            success: on_success,
        });
    }

    function ap_execute_reset_pass_ajax_operations( operation, operation_nonce, username, channel = '', otp = '', before_send ='', on_success='') {
        $.ajax({
            url: apUser.ajaxUrl,
            type: 'post',
            dataType: 'json',
            data:{
                action: 'ap_execute_reset_pass_ajax_operations',
                operation: operation,
                channel: channel,
                nonce: operation_nonce,
                username: username,
                otp: otp,
                postId: data.postId,
                formId: data.formId,
                referrer: window.location.href
            },
            beforeSend: before_send,
            success: on_success,
        });
    }

    function startCountdown($time) {
         let time = $time.text().split(':');
         let totalSeconds = time[0] * 60 + time[1] * 1;
         let timer = totalSeconds, minutes, seconds;
         let interval = setInterval(function () {
            minutes = parseInt(timer / 60, 10);
            seconds = parseInt(timer % 60, 10);
            minutes = minutes < 10 ? "0" + minutes : minutes;
            seconds = seconds < 10 ? "0" + seconds : seconds;
            $time.text(minutes + ":" + seconds);
            if (--timer < 0) {
                clearInterval(interval);
                $('.ap-otp-heading p').text(__('Try Again Now!!!'));
            }
        }, 1000);
    }

})(jQuery, wp);
